<template>
  <div>
    <div class="orders-list">
      <div class="orders-list_search">
        <span>Search by name:</span>
        <input
          v-model.trim="search"
          type="text"
        >
      </div>
      <div class="orders-list_row head">
        <span>name</span>
        <span>deliveryType</span>
        <span>date</span>
        <span>products</span>
        <span>needCall</span>
      </div>
      <div
        v-for="order in orders"
        :key="order.id"
        class="orders-list_row"
      >
        <span>{{ order.name }}</span>
        <span>{{ order.deliveryType }}</span>
        <span>{{ order.date }}</span>
        <span>{{ order.products }}</span>
        <span>{{ order.needCall }}</span>
      </div>
    </div>
  </div>
</template>

<script>
import { OrdersApi } from '../api/OrdersApi'
import { ordersUrl } from '../config/config'
import { DeliveryTypeMapping } from '../constants/Orders'
import { ProductsMapping } from '../constants/Products'

export default {
  data: function () {
    return {
      orders: [],
      allOrders: [],
      search: ''
    }
  },
  watch: {
    search: function (val) {
      this.getOrders()
    }
  },
  mounted: async function () {
    const api = new OrdersApi(ordersUrl)
    const res = await api.getOrders()
    if (res.IsSuccess) {
      this.allOrders = res.Data
      this.getOrders()
    } else {
      console.error(res.StatusCode, res.Errors)
    }
  },
  methods: {
    getOrders: function () {
      const orders = []
      this.allOrders.forEach((el) => {
        if (!this.search || ~el.name.indexOf(this.search)) {
          const elem = {
            ...el,
            deliveryType: DeliveryTypeMapping[el.deliveryType],
            date: new Date(el.date).toLocaleDateString(),
            products: ProductsMapping[el.products],
            needCall: el.needCall ? 'Yes' : 'No'
          }
          orders.push(elem)
        }
      })
      this.orders = orders
    }
  }
}
</script>
